puts __FILE__ if $JFDEBUG
# random_tin.rb Copyright (c) 2007 jim.foltz@gmail.com
module JF
    module RandomizeTIN
        def self.randomTin
            @h ||= "1"
            @p ||= "原地形边界"
            sel = Sketchup.active_model.selection[0]
            return unless sel
            return  unless sel.typename == "Group"
            res = UI.inputbox(["抖动高度 ", "边界 "],[@h.to_l, @p], ["","原地形边界|垂直抖动"], "随机地形抖动")
            return unless res
            @h       = res[0]
            @p       = res[1]
            faces    = sel.entities.find_all{|e| e.is_a?(Sketchup::Face)}
            mesh     = Geom::PolygonMesh.new
            edge_pts = []
            faces.each {|f|
                pts = []
                f.vertices.each{|v|
                    pts << v.position
                    if v.edges.length < 6
                        edge_pts << v.position
                    end
                }
                mesh.add_polygon pts
            }
            mesh.points.each {|pt|
                if @p=="原地形边界" and edge_pts.include?(pt)
                    next
                end
                i = mesh.point_index pt
                r = rand(@h*2.0+1.0)-@h
                z = pt.z
                z += r
                x = pt.x
                y = pt.y
                mesh.set_point(i, [x, y, z])
            }
            if Sketchup.version.to_f > 7.0
                Sketchup.active_model.start_operation("随机地形抖动", true)
            else
                Sketchup.start_operation("随机地形抖动")
            end
            g = Sketchup.active_model.active_entities.add_group
            g.entities.add_faces_from_mesh(mesh)
            g.transformation = sel.transformation
            Sketchup.active_model.commit_operation
        end
    end
end

unless file_loaded?("random_tin.rb")
    # UI.menu("Plugins").add_item("Randomize TIN") { JF::RandomizeTIN.randomTin() }

			path = Sketchup.find_support_file("Plugins/random_tin")
  randomtin_tb = UI::Toolbar.new("随机地形抖动")
  cmd1 = UI::Command.new("随机地形抖动") { JF::RandomizeTIN.randomTin() } 
  cmd1.small_icon = File.join(path,"icons/random_tin24.png")
  cmd1.large_icon = File.join(path,"icons/random_tin36.png")
  cmd1.tooltip = "随机地形抖动"
  cmd1.status_bar_text = "选择一个网格地形的组"
  randomtin_tb.add_item(cmd1)
  randomtin_tb.show
      file_loaded("random_tin.rb")
end
